import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import { FlexGrid } from '@mescius/wijmo.grid';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
// generate some random data
var countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','), data = [];
for (var i = 0; i < 200; i++) {
data.push({
id: i,
country: countries[i % countries.length],
downloads: Math.round(Math.random() * 20000),
sales: Math.random() * 10000,
expenses: Math.random() * 5000,
num1: Math.random() * 5000,
num2: Math.random() * 5000,
num3: Math.random() * 5000,
num4: Math.random() * 5000,
num5: Math.random() * 5000,
});
}
// default behavior: allow column reordering
let theGrid = new FlexGrid('#theGrid', {
itemsSource: data,
allowPinning: 'Both',
});
// Add event listener for the new freeze cells button
document.querySelector('#btnFreezeCells').addEventListener('click', freezeCells);
function freezeCells() {
const frozenCells = {
top: parseInt(document.getElementById('topFreeze').value) || 0,
bottom: parseInt(document.getElementById('bottomFreeze').value) || 0,
left: parseInt(document.getElementById('leftFreeze').value) || 0,
right: parseInt(document.getElementById('rightFreeze').value) || 0
};
// Apply the frozenCells to the grid
theGrid.frozenCells = frozenCells;
// Read back what was actually applied
const appliedFrozenCells = theGrid.frozenCells;
// Prepare the message
const messageElement = document.getElementById('errorMsg');
let appliedFreezeMsg = "Applied freeze: ";
if (Object.keys(appliedFrozenCells).length === 0) {
appliedFreezeMsg += "None";
}
else {
appliedFreezeMsg += Object.entries(appliedFrozenCells)
.map(([key, value]) => `${key}: ${value}`)
.join(', ');
}
// Display the message
messageElement.style.display = 'block';
messageElement.style.color = 'green';
messageElement.textContent = appliedFreezeMsg;
}
// Add event listeners for disabling inputs
const inputs = {
top: document.getElementById('topFreeze'),
bottom: document.getElementById('bottomFreeze'),
left: document.getElementById('leftFreeze'),
right: document.getElementById('rightFreeze')
};
// Add event listener for the clear freeze cells button
document.querySelector('#btnClearFreezeCells').addEventListener('click', clearFreezeCells);
function clearFreezeCells() {
theGrid.frozenCells = { top: 0, bottom: 0, left: 0, right: 0 };
Object.values(inputs).forEach(input => input.value = '0');
handleInputChange();
document.getElementById('errorMsg').innerHTML = "";
}
const handleInputChange = () => {
const topValue = parseInt(inputs.top.value, 10) || 0;
const bottomValue = parseInt(inputs.bottom.value, 10) || 0;
const leftValue = parseInt(inputs.left.value, 10) || 0;
const rightValue = parseInt(inputs.right.value, 10) || 0;
toggleDisable(topValue, inputs.bottom);
toggleDisable(bottomValue, inputs.top);
toggleDisable(leftValue, inputs.right);
toggleDisable(rightValue, inputs.left);
};
// Attach input event listeners
Object.values(inputs).forEach(input => {
input.addEventListener('input', handleInputChange);
});
const toggleDisable = (primaryValue, secondaryElement) => {
secondaryElement.disabled = primaryValue > 0;
};
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Frozen Rows and Columns</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js"
integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA=="
crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<div class="flex-grow-0">
<div id="freezeControls">
<h2 class="text-center">Grid Freeze Cells API</h2>
<div class="inputs">
<div class="inputRow">
<div class="ctrl">
<label for="topFreeze" class="form-label">Freeze Rows (Top):</label>
<input type="number" id="topFreeze" min="0" value="0" class="form-control" />
</div>
<div class="ctrl">
<label for="bottomFreeze" class="form-label">Freeze Rows (Bottom):</label>
<input type="number" id="bottomFreeze" min="0" value="0" class="form-control" />
</div>
</div>
<div class="inputRow">
<div class="ctrl">
<label for="leftFreeze" class="form-label">Freeze Columns (Left):</label>
<input type="number" id="leftFreeze" min="0" value="0" class="form-control" />
</div>
<div class="ctrl">
<label for="rightFreeze" class="form-label">Freeze Columns (Right):</label>
<input type="number" id="rightFreeze" min="0" value="0" class="form-control" />
</div>
</div>
</div>
<div class="d-grid gap-2 freezeBtns">
<button type="button" class="btn btn-primary" id="btnFreezeCells">Apply Freeze</button>
<button type="button" class="btn btn-primary" id="btnClearFreezeCells">Clear Freeze</button>
</div>
<p id="errorMsg" class="text-center"></p>
</div>
</div>
<div class="flex-grow-1 flex-container">
<div id="theGrid"></div>
</div>
</div>
</body>
</html>
.wj-flexgrid {
max-height: 400px;
max-width: 1000px;
margin: 10px 0;
}
/* style frozen cells */
.wj-cell.wj-frozen:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected),
.wj-cell.wj-frozen.wj-alt:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected) {
background: rgb(255, 255, 125);
}
html,
body {
height: 800px;
margin: 0;
padding: 0;
overflow: hidden;
}
.container-fluid {
height: 100vh;
display: flex;
flex-direction: column;
padding: 15px;
box-sizing: border-box;
overflow: hidden;
margin: 0px 10px
}
#freezeControls {
max-width:1000px;
background-color: #f8f9fa;
border-radius: 8px;
box-shadow: 0 2px 10px rgba(0, 0, 0, 0.1);
padding: 20px;
margin-bottom: 15px;
}
#freezeControls h2 {
color: #007bff;
margin-bottom: 20px;
}
.control-group {
margin-bottom: 15px;
}
#errorMsg {
color: #dc3545;
font-weight: bold;
margin-top: 10px;
}
.grid-container {
flex-grow: 1;
min-height: 0;
/* Important for Firefox */
display: flex;
flex-direction: column;
}
.inputRow{
display: flex;
justify-content: space-between;
}
.ctrl{
width: 100%;
margin: 0px 10px;
}
.freezeBtns button{
margin: 10px
}
.flex-container {
display: flex;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import '@angular/compiler';
import { Component, enableProdMode, NgModule, ViewChild } from '@angular/core';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { BrowserModule } from '@angular/platform-browser';
import * as wjcGrid from '@mescius/wijmo.grid';
import { WjGridModule } from '@mescius/wijmo.angular2.grid';
//
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
data: any[];
// DataSvc will be passed by derived classes
constructor() {
this.data = this._getData();
}
@ViewChild('flex', { static: true }) grid: wjcGrid.FlexGrid;
freezeCells(
topFreeze: HTMLInputElement,
bottomFreeze: HTMLInputElement,
leftFreeze: HTMLInputElement,
rightFreeze: HTMLInputElement,
) {
const frozenCells = {
top: parseInt(topFreeze.value) || 0,
bottom: parseInt(bottomFreeze.value) || 0,
left: parseInt(leftFreeze.value) || 0,
right: parseInt(rightFreeze.value) || 0,
};
// Apply the frozenCells to the grid
this.grid.frozenCells = frozenCells;
// Read back what was actually applied
const appliedFrozenCells = this.grid.frozenCells;
// Prepare the message
const messageElement = document.getElementById('errorMsg');
let appliedFreezeMsg = 'Applied freeze: ';
if (Object.keys(appliedFrozenCells).length === 0) {
appliedFreezeMsg += 'None';
} else {
appliedFreezeMsg += (Object as any)
.entries(appliedFrozenCells)
.map(([key, value]: [string, any]) => `${key}: ${value}`)
.join(', ');
}
// Display the message
messageElement.style.display = 'block';
messageElement.style.color = 'green';
messageElement.textContent = appliedFreezeMsg;
}
clearFreezeCells(
topFreeze: HTMLInputElement,
bottomFreeze: HTMLInputElement,
leftFreeze: HTMLInputElement,
rightFreeze: HTMLInputElement,
) {
this.grid.frozenCells = { top: 0, bottom: 0, left: 0, right: 0 };
topFreeze.value = bottomFreeze.value = leftFreeze.value = rightFreeze.value = '0';
this.handleInputChange(topFreeze, bottomFreeze, leftFreeze, rightFreeze);
document.getElementById('errorMsg').innerHTML = '';
}
handleInputChange(
topFreeze: HTMLInputElement,
bottomFreeze: HTMLInputElement,
leftFreeze: HTMLInputElement,
rightFreeze: HTMLInputElement,
) {
const topValue = parseInt(topFreeze.value, 10) || 0;
const bottomValue = parseInt(bottomFreeze.value, 10) || 0;
const leftValue = parseInt(leftFreeze.value, 10) || 0;
const rightValue = parseInt(rightFreeze.value, 10) || 0;
this.toggleDisable(topValue, bottomFreeze);
this.toggleDisable(bottomValue, topFreeze);
this.toggleDisable(leftValue, rightFreeze);
this.toggleDisable(rightValue, leftFreeze);
}
toggleDisable(primaryValue: number, secondaryElement: HTMLInputElement) {
secondaryElement.disabled = primaryValue > 0;
}
private _getData() {
// generate some random data
var countries = 'US,Germany,UK,Japan,Italy,Greece'.split(','),
data = [];
for (var i = 0; i < 200; i++) {
data.push({
id: i,
country: countries[i % countries.length],
downloads: Math.round(Math.random() * 20000),
sales: Math.random() * 10000,
expenses: Math.random() * 5000,
num1: Math.random() * 5000,
num2: Math.random() * 5000,
num3: Math.random() * 5000,
num4: Math.random() * 5000,
num5: Math.random() * 5000,
});
}
return data;
}
}
//
@NgModule({
imports: [WjGridModule, BrowserModule],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule {}
//
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Frozen Rows and Columns</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="https://cdn.jsdelivr.net/npm/core-js/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<main className="container-fluid">
<div class="flex-grow-0">
<div id="freezeControls">
<h2 class="text-center">Grid Freeze Cells API</h2>
<div class="inputs">
<div class="inputRow">
<div class="ctrl">
<label for="topFreeze" class="form-label">Freeze Rows (Top):</label>
<input #topFreeze type="number" id="topFreeze" min="0" value="0" class="form-control"
(change)="handleInputChange(topFreeze, bottomFreeze, leftFreeze, rightFreeze)" />
</div>
<div class="ctrl">
<label for="bottomFreeze" class="form-label">Freeze Rows (Bottom):</label>
<input #bottomFreeze type="number" id="bottomFreeze" min="0" value="0" class="form-control"
(change)="handleInputChange(topFreeze, bottomFreeze, leftFreeze, rightFreeze)" />
</div>
</div>
<div class="inputRow">
<div class="ctrl">
<label for="leftFreeze" class="form-label">Freeze Columns (Left):</label>
<input #leftFreeze type="number" id="leftFreeze" min="0" value="0" class="form-control"
(change)="handleInputChange(topFreeze, bottomFreeze, leftFreeze, rightFreeze)" />
</div>
<div class="ctrl">
<label for="rightFreeze" class="form-label">Freeze Columns (Right):</label>
<input #rightFreeze type="number" id="rightFreeze" min="0" value="0" class="form-control"
(change)="handleInputChange(topFreeze, bottomFreeze, leftFreeze, rightFreeze)" />
</div>
</div>
</div>
<div class="d-grid gap-2 freezeBtns">
<button type="button" class="btn btn-primary" id="btnFreezeCells"
(click)="freezeCells(topFreeze, bottomFreeze, leftFreeze, rightFreeze)">Apply Freeze</button>
<button type="button" class="btn btn-primary" id="btnClearFreezeCells" (click)="clearFreezeCells(topFreeze, bottomFreeze, leftFreeze, rightFreeze)">Clear
Freeze</button>
</div>
<p id="errorMsg" class="text-center">{{ errorMessage }}</p>
</div>
</div>
<div class="flex-grow-1">
<wj-flex-grid #flex [allowPinning]="'Both'" [(itemsSource)]="data"></wj-flex-grid>
</div>
</main>
.wj-flexgrid {
max-height: 400px;
max-width: 1000px;
margin: 10px 0;
}
/* style frozen cells */
.wj-cell.wj-frozen:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected),
.wj-cell.wj-frozen.wj-alt:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected) {
background: rgb(255, 255, 125);
}
html,
body {
height: 800px;
margin: 0;
padding: 0;
overflow: hidden;
}
.container-fluid {
height: 100vh;
display: flex;
flex-direction: column;
padding: 15px;
box-sizing: border-box;
overflow: hidden;
margin: 0px 10px
}
#freezeControls {
max-width:1000px;
background-color: #f8f9fa;
border-radius: 8px;
box-shadow: 0 2px 10px rgba(0, 0, 0, 0.1);
padding: 20px;
margin-bottom: 15px;
}
#freezeControls h2 {
color: #007bff;
margin-bottom: 20px;
}
.control-group {
margin-bottom: 15px;
}
#errorMsg {
color: #dc3545;
font-weight: bold;
margin-top: 10px;
}
.grid-container {
flex-grow: 1;
min-height: 0;
/* Important for Firefox */
display: flex;
flex-direction: column;
}
.inputRow{
display: flex;
justify-content: space-between;
}
.ctrl{
width: 100%;
margin: 0px 10px;
}
.freezeBtns button{
margin: 10px
}
.flex-container {
display: flex;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
target: 'ES2022',
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
typescript: {
exports: 'ts',
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm',
},
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/',
'agpcdn:': 'https://cdn.jsdelivr.net/npm/'
},
packageConfigPaths: ['/node_modules/*/package.json', '/node_modules/@angular/*/package.json', '/node_modules/@mescius/*/package.json'],
map: {
'core-js': 'agpcdn:core-js@2.6.12/client/shim.min.js',
'typescript': 'agpcdn:typescript@5.9.3/lib/typescript.min.js',
rxjs: 'agpcdn:rxjs@7.8.1/dist/bundles/rxjs.umd.min.js',
'systemjs-plugin-css': 'agpcdn:systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.angular2.chart.analytics': 'cdn:@mescius/wijmo.angular2.chart.analytics/index.js',
'@mescius/wijmo.angular2.chart.animation': 'cdn:@mescius/wijmo.angular2.chart.animation/index.js',
'@mescius/wijmo.angular2.chart.annotation': 'cdn:@mescius/wijmo.angular2.chart.annotation/index.js',
'@mescius/wijmo.angular2.chart.finance.analytics': 'cdn:@mescius/wijmo.angular2.chart.finance.analytics/index.js',
'@mescius/wijmo.angular2.chart.finance': 'cdn:@mescius/wijmo.angular2.chart.finance/index.js',
'@mescius/wijmo.angular2.chart.hierarchical': 'cdn:@mescius/wijmo.angular2.chart.hierarchical/index.js',
'@mescius/wijmo.angular2.chart.interaction': 'cdn:@mescius/wijmo.angular2.chart.interaction/index.js',
'@mescius/wijmo.angular2.chart.radar': 'cdn:@mescius/wijmo.angular2.chart.radar/index.js',
'@mescius/wijmo.angular2.chart.map': 'cdn:@mescius/wijmo.angular2.chart.map/index.js',
'@mescius/wijmo.angular2.chart': 'cdn:@mescius/wijmo.angular2.chart/index.js',
'@mescius/wijmo.angular2.core': 'cdn:@mescius/wijmo.angular2.core/index.js',
'@mescius/wijmo.angular2.gauge': 'cdn:@mescius/wijmo.angular2.gauge/index.js',
'@mescius/wijmo.angular2.grid.detail': 'cdn:@mescius/wijmo.angular2.grid.detail/index.js',
'@mescius/wijmo.angular2.grid.filter': 'cdn:@mescius/wijmo.angular2.grid.filter/index.js',
'@mescius/wijmo.angular2.grid.grouppanel': 'cdn:@mescius/wijmo.angular2.grid.grouppanel/index.js',
'@mescius/wijmo.angular2.grid.search': 'cdn:@mescius/wijmo.angular2.grid.search/index.js',
'@mescius/wijmo.angular2.grid.multirow': 'cdn:@mescius/wijmo.angular2.grid.multirow/index.js',
'@mescius/wijmo.angular2.grid.sheet': 'cdn:@mescius/wijmo.angular2.grid.sheet/index.js',
'@mescius/wijmo.angular2.grid.transposed': 'cdn:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'cdn:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
'@mescius/wijmo.angular2.grid': 'cdn:@mescius/wijmo.angular2.grid/index.js',
'@mescius/wijmo.angular2.input': 'cdn:@mescius/wijmo.angular2.input/index.js',
'@mescius/wijmo.angular2.olap': 'cdn:@mescius/wijmo.angular2.olap/index.js',
'@mescius/wijmo.angular2.viewer': 'cdn:@mescius/wijmo.angular2.viewer/index.js',
'@mescius/wijmo.angular2.nav': 'cdn:@mescius/wijmo.angular2.nav/index.js',
'@mescius/wijmo.angular2.directivebase': 'cdn:@mescius/wijmo.angular2.directivebase/index.js',
'@mescius/wijmo.angular2.barcode.common': 'cdn:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'cdn:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'cdn:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'agpcdn:jszip@3.10.1/dist/jszip.min.js',
'@angular/core': 'pcdn:@angular/core@21.1.0/fesm2022/core.mjs',
'@angular/core/primitives/di': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-di.mjs',
'@angular/core/primitives/signals': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-signals.mjs',
'@angular/core/primitives/event-dispatch': 'pcdn:@angular/core@21.1.0/fesm2022/primitives-event-dispatch.mjs',
'@angular/common': 'pcdn:@angular/common@21.1.0/fesm2022/common.mjs',
'@angular/common/http': 'pcdn:@angular/common@21.1.0/fesm2022/http.mjs',
'@angular/compiler': 'pcdn:@angular/compiler@21.1.0/fesm2022/compiler.mjs',
'@angular/platform-browser': 'pcdn:@angular/platform-browser@21.1.0/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'pcdn:@angular/platform-browser-dynamic@21.1.0/fesm2022/platform-browser-dynamic.mjs',
'@angular/router': 'pcdn:@angular/router@21.1.0/fesm2022/router.mjs',
'@angular/forms': 'pcdn:@angular/forms@21.1.0/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
'./src': {
defaultExtension: 'ts',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

<template>
<main class="container-fluid">
<div class="flex-grow-0">
<div id="freezeControls">
<h2 class="text-center">Grid Freeze Cells API</h2>
<div class="inputs">
<div class="inputRow">
<div class="ctrl">
<label for="topFreeze" class="form-label">Freeze Rows (Top):</label>
<input v-model.number="topFreeze" type="number" id="topFreeze" min="0" value="0" class="form-control"
@change="handleInputChange" />
</div>
<div class="ctrl">
<label for="bottomFreeze" class="form-label">Freeze Rows (Bottom):</label>
<input v-model.number="bottomFreeze" type="number" id="bottomFreeze" min="0" value="0" class="form-control"
@change="handleInputChange" />
</div>
</div>
<div class="inputRow">
<div class="ctrl">
<label for="leftFreeze" class="form-label">Freeze Columns (Left):</label>
<input v-model.number="leftFreeze" type="number" id="leftFreeze" min="0" value="0" class="form-control"
@change="handleInputChange" />
</div>
<div class="ctrl">
<label for="rightFreeze" class="form-label">Freeze Columns (Right):</label>
<input v-model.number="rightFreeze" type="number" id="rightFreeze" min="0" value="0" class="form-control"
@change="handleInputChange" />
</div>
</div>
</div>
<div class="d-grid gap-2 freezeBtns">
<button type="button" class="btn btn-primary" id="btnFreezeCells" @click="freezeCells">Apply Freeze</button>
<button type="button" class="btn btn-primary" id="btnClearFreezeCells" @click="clearFreezeCells">Clear Freeze</button>
</div>
<p id="errorMsg" class="text-center">{{ errorMessage }}</p>
</div>
</div>
<div class="row flex-grow-1">
<div class="col-12">
<wj-flex-grid id="sample-grid" :allowPinning="'Both'" :itemsSource="data"
:initialized="gridInitialized">
</wj-flex-grid>
</div>
</div>
</main>
</template>
<script setup>
import { ref, onMounted } from "vue";
const data = ref(_getData());
const inputs = ref({});
const grid = ref(null);
onMounted(function () {
inputs.value = {
top: document.getElementById("topFreeze"),
bottom: document.getElementById("bottomFreeze"),
left: document.getElementById("leftFreeze"),
right: document.getElementById("rightFreeze"),
};
Object.values(inputs.value).forEach((input) => (input.value = "0"));
});
function gridInitialized(ctl) {
grid.value = ctl;
}
function freezeCells() {
const frozenCells = {
top: parseInt(document.getElementById("topFreeze").value) || 0,
bottom: parseInt(document.getElementById("bottomFreeze").value) || 0,
left: parseInt(document.getElementById("leftFreeze").value) || 0,
right: parseInt(document.getElementById("rightFreeze").value) || 0,
};
// Apply the frozenCells to the grid
grid.value.frozenCells = frozenCells;
// Read back what was actually applied
const appliedFrozenCells = grid.value.frozenCells;
// Prepare the message
const messageElement = document.getElementById("errorMsg");
let appliedFreezeMsg = "Applied freeze: ";
if (Object.keys(appliedFrozenCells).length === 0) {
appliedFreezeMsg += "None";
} else {
appliedFreezeMsg += Object.entries(appliedFrozenCells)
.map(([key, value]) => `${key}: ${value}`)
.join(", ");
}
// Display the message
messageElement.style.display = "block";
messageElement.style.color = "green";
messageElement.textContent = appliedFreezeMsg;
}
function clearFreezeCells() {
grid.value.frozenCells = { top: 0, bottom: 0, left: 0, right: 0 };
Object.values(inputs.value).forEach((input) => (input.value = "0"));
handleInputChange(topFreeze, bottomFreeze, leftFreeze, rightFreeze);
document.getElementById("errorMsg").innerHTML = "";
}
function handleInputChange() {
const topValue = parseInt(inputs.value.top.value, 10) || 0;
const bottomValue = parseInt(inputs.value.bottom.value, 10) || 0;
const leftValue = parseInt(inputs.value.left.value, 10) || 0;
const rightValue = parseInt(inputs.value.right.value, 10) || 0;
toggleDisable(topValue, inputs.value.bottom);
toggleDisable(bottomValue, inputs.value.top);
toggleDisable(leftValue, inputs.value.right);
toggleDisable(rightValue, inputs.value.left);
}
function toggleDisable(primaryValue, secondaryElement) {
secondaryElement.disabled = primaryValue > 0;
}
function _getData() {
// generate some random data
var countries = "US,Germany,UK,Japan,Italy,Greece".split(","),
data = [];
for (var i = 0; i < 200; i++) {
data.push({
id: i,
country: countries[i % countries.length],
downloads: Math.round(Math.random() * 20000),
sales: Math.random() * 10000,
expenses: Math.random() * 5000,
num1: Math.random() * 5000,
num2: Math.random() * 5000,
num3: Math.random() * 5000,
num4: Math.random() * 5000,
num5: Math.random() * 5000,
});
}
return data;
}
</script>
<style>
.wj-flexgrid {
max-height: 400px;
max-width: 1000px;
margin: 10px 0;
}
/* style frozen cells */
.wj-cell.wj-frozen:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected),
.wj-cell.wj-frozen.wj-alt:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected) {
background: rgb(255, 255, 125);
}
html,
body {
height: 800px;
margin: 0;
padding: 0;
overflow: hidden;
}
.container-fluid {
height: 100vh;
display: flex;
flex-direction: column;
padding: 15px;
box-sizing: border-box;
overflow: hidden;
margin: 0px 10px
}
#freezeControls {
max-width:1000px;
background-color: #f8f9fa;
border-radius: 8px;
box-shadow: 0 2px 10px rgba(0, 0, 0, 0.1);
padding: 20px;
margin-bottom: 15px;
}
#freezeControls h2 {
color: #007bff;
margin-bottom: 20px;
}
.control-group {
margin-bottom: 15px;
}
#errorMsg {
color: #dc3545;
font-weight: bold;
margin-top: 10px;
}
.grid-container {
flex-grow: 1;
min-height: 0;
/* Important for Firefox */
display: flex;
flex-direction: column;
}
.inputRow{
display: flex;
justify-content: space-between;
}
.ctrl{
width: 100%;
margin: 0px 10px;
}
.freezeBtns button{
margin: 10px
}
.flex-container {
display: flex;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo FlexGrid Frozen Rows and Columns</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' },
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.vue2.chart.analytics': 'cdn:@mescius/wijmo.vue2.chart.analytics/index.js',
'@mescius/wijmo.vue2.chart.animation': 'cdn:@mescius/wijmo.vue2.chart.animation/index.js',
'@mescius/wijmo.vue2.chart.annotation': 'cdn:@mescius/wijmo.vue2.chart.annotation/index.js',
'@mescius/wijmo.vue2.chart.finance.analytics': 'cdn:@mescius/wijmo.vue2.chart.finance.analytics/index.js',
'@mescius/wijmo.vue2.chart.finance': 'cdn:@mescius/wijmo.vue2.chart.finance/index.js',
'@mescius/wijmo.vue2.chart.hierarchical': 'cdn:@mescius/wijmo.vue2.chart.hierarchical/index.js',
'@mescius/wijmo.vue2.chart.interaction': 'cdn:@mescius/wijmo.vue2.chart.interaction/index.js',
'@mescius/wijmo.vue2.chart.radar': 'cdn:@mescius/wijmo.vue2.chart.radar/index.js',
'@mescius/wijmo.vue2.chart.map': 'cdn:@mescius/wijmo.vue2.chart.map/index.js',
'@mescius/wijmo.vue2.chart': 'cdn:@mescius/wijmo.vue2.chart/index.js',
'@mescius/wijmo.vue2.core': 'cdn:@mescius/wijmo.vue2.core/index.js',
'@mescius/wijmo.vue2.gauge': 'cdn:@mescius/wijmo.vue2.gauge/index.js',
'@mescius/wijmo.vue2.grid.detail': 'cdn:@mescius/wijmo.vue2.grid.detail/index.js',
'@mescius/wijmo.vue2.grid.filter': 'cdn:@mescius/wijmo.vue2.grid.filter/index.js',
'@mescius/wijmo.vue2.grid.grouppanel': 'cdn:@mescius/wijmo.vue2.grid.grouppanel/index.js',
'@mescius/wijmo.vue2.grid.search': 'cdn:@mescius/wijmo.vue2.grid.search/index.js',
'@mescius/wijmo.vue2.grid.multirow': 'cdn:@mescius/wijmo.vue2.grid.multirow/index.js',
'@mescius/wijmo.vue2.grid.sheet': 'cdn:@mescius/wijmo.vue2.grid.sheet/index.js',
'@mescius/wijmo.vue2.grid.transposed': 'cdn:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'cdn:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
'@mescius/wijmo.vue2.grid': 'cdn:@mescius/wijmo.vue2.grid/index.js',
'@mescius/wijmo.vue2.input': 'cdn:@mescius/wijmo.vue2.input/index.js',
'@mescius/wijmo.vue2.olap': 'cdn:@mescius/wijmo.vue2.olap/index.js',
'@mescius/wijmo.vue2.viewer': 'cdn:@mescius/wijmo.vue2.viewer/index.js',
'@mescius/wijmo.vue2.nav': 'cdn:@mescius/wijmo.vue2.nav/index.js',
'@mescius/wijmo.vue2.base': 'cdn:@mescius/wijmo.vue2.base/index.js',
'@mescius/wijmo.vue2.barcode.common': 'cdn:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'cdn:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'cdn:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
vue: 'pcdn:vue@3.4.21/dist/vue.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'@vue/compiler-dom': 'pcdn:@vue/compiler-dom@3.4.21/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom': 'pcdn:@vue/runtime-dom@3.4.21/dist/runtime-dom.global.prod.js',
'@vue/shared': 'pcdn:@vue/shared@3.4.21/dist/shared.cjs.js',
'vue-loader': 'pcdn:systemjs-vue-browser@1.0.11/index.js',
//'systemjs-plugin-vue': 'pcdn:systemjs-plugin-vue@1.2.0/index.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
rxjs: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
wijmo: {
defaultExtension: 'js',
},
},
});
})(this);

import "bootstrap.css";
import "@mescius/wijmo.styles/wijmo.css";
import ReactDOM from "react-dom/client";
import React, { useEffect, useRef, useState } from "react";
import useEvent from "react-use-event-hook";
import * as wjGrid from "@mescius/wijmo.react.grid";
import "./app.css";
import { data } from "./data";
function App() {
const grid = useRef(null);
const [inputs, setInputs] = useState({
top: null,
bottom: null,
left: null,
right: null,
});
useEffect(() => {
setInputs({
top: document.getElementById("topFreeze"),
bottom: document.getElementById("bottomFreeze"),
left: document.getElementById("leftFreeze"),
right: document.getElementById("rightFreeze"),
});
}, []);
const gridInitialized = useEvent((ctl) => {
grid.current = ctl;
});
const freezeCells = () => {
const frozenCells = {
top: parseInt(document.getElementById("topFreeze").value) || 0,
bottom: parseInt(document.getElementById("bottomFreeze").value) || 0,
left: parseInt(document.getElementById("leftFreeze").value) || 0,
right: parseInt(document.getElementById("rightFreeze").value) || 0,
};
// Apply the frozenCells to the grid
grid.current.frozenCells = frozenCells;
// Read back what was actually applied
const appliedFrozenCells = grid.current.frozenCells;
// Prepare the message
const messageElement = document.getElementById("errorMsg");
let appliedFreezeMsg = "Applied freeze: ";
if (Object.keys(appliedFrozenCells).length === 0) {
appliedFreezeMsg += "None";
}
else {
appliedFreezeMsg += Object
.entries(appliedFrozenCells)
.map(([key, value]) => `${key}: ${value}`)
.join(", ");
}
// Display the message
messageElement.style.display = "block";
messageElement.style.color = "green";
messageElement.textContent = appliedFreezeMsg;
};
const clearFreezeCells = () => {
grid.current.frozenCells = { top: 0, bottom: 0, left: 0, right: 0 };
Object.values(inputs).forEach((input) => (input.value = "0"));
handleInputChange();
document.getElementById("errorMsg").innerHTML = "";
};
const handleInputChange = () => {
const topValue = parseInt(inputs.top.value, 10) || 0;
const bottomValue = parseInt(inputs.bottom.value, 10) || 0;
const leftValue = parseInt(inputs.left.value, 10) || 0;
const rightValue = parseInt(inputs.right.value, 10) || 0;
toggleDisable(topValue, inputs.bottom);
toggleDisable(bottomValue, inputs.top);
toggleDisable(leftValue, inputs.right);
toggleDisable(rightValue, inputs.left);
};
const toggleDisable = (primaryValue, secondaryElement) => {
secondaryElement.disabled = primaryValue > 0;
};
return (<main className="container-fluid">
<div className="flex-grow-0">
<div id="freezeControls">
<h2 className="text-center">Grid Freeze Cells API</h2>
<div className="inputs">
<div className="inputRow">
<div className="ctrl">
<label htmlFor="topFreeze" className="form-label">
Freeze Rows (Top):
</label>
<input type="number" id="topFreeze" min="0" defaultValue="0" className="form-control" onChange={handleInputChange}/>
</div>
<div className="ctrl">
<label htmlFor="bottomFreeze" className="form-label">
Freeze Rows (Bottom):
</label>
<input type="number" id="bottomFreeze" min="0" defaultValue="0" className="form-control" onChange={handleInputChange}/>
</div>
</div>
<div className="inputRow">
<div className="ctrl">
<label htmlFor="leftFreeze" className="form-label">
Freeze Columns (Left):
</label>
<input type="number" id="leftFreeze" min="0" defaultValue="0" className="form-control" onChange={handleInputChange}/>
</div>
<div className="ctrl">
<label htmlFor="rightFreeze" className="form-label">
Freeze Columns (Right):
</label>
<input type="number" id="rightFreeze" min="0" defaultValue="0" className="form-control" onChange={handleInputChange}/>
</div>
</div>
</div>
<div className="d-grid gap-2 freezeBtns">
<button type="button" className="btn btn-primary" id="btnFreezeCells" onClick={freezeCells}>
Apply Freeze
</button>
<button type="button" className="btn btn-primary" id="btnClearFreezeCells" onClick={clearFreezeCells}>
Clear Freeze
</button>
</div>
<p id="errorMsg" className="text-center"></p>
</div>
</div>
<div className="row flex-grow-1">
<div className="col-12">
<wjGrid.FlexGrid id="sample-grid" allowPinning="Both" itemsSource={data} initialized={gridInitialized}/>
</div>
</div>
</main>);
}
const container = document.getElementById("app");
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo Wijmo FlexGrid Frozen Rows and Columns</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.19.40/dist/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.wj-flexgrid {
max-height: 400px;
max-width: 1000px;
margin: 10px 0;
}
/* style frozen cells */
.wj-cell.wj-frozen:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected),
.wj-cell.wj-frozen.wj-alt:not(.wj-header):not(.wj-group):not(.wj-state-selected):not(.wj-state-multi-selected) {
background: rgb(255, 255, 125);
}
html,
body {
height: 800px;
margin: 0;
padding: 0;
overflow: hidden;
}
.container-fluid {
height: 100vh;
display: flex;
flex-direction: column;
padding: 15px;
box-sizing: border-box;
overflow: hidden;
margin: 0px 10px
}
#freezeControls {
max-width:1000px;
background-color: #f8f9fa;
border-radius: 8px;
box-shadow: 0 2px 10px rgba(0, 0, 0, 0.1);
padding: 20px;
margin-bottom: 15px;
}
#freezeControls h2 {
color: #007bff;
margin-bottom: 20px;
}
.control-group {
margin-bottom: 15px;
}
#errorMsg {
color: #dc3545;
font-weight: bold;
margin-top: 10px;
}
.grid-container {
flex-grow: 1;
min-height: 0;
/* Important for Firefox */
display: flex;
flex-direction: column;
}
.inputRow{
display: flex;
justify-content: space-between;
}
.ctrl{
width: 100%;
margin: 0px 10px;
}
.freezeBtns button{
margin: 10px
}
.flex-container {
display: flex;
}
const getData = () => {
// generate some random data
var countries = "US,Germany,UK,Japan,Italy,Greece".split(","), data = [];
for (var i = 0; i < 200; i++) {
data.push({
id: i,
country: countries[i % countries.length],
downloads: Math.round(Math.random() * 20000),
sales: Math.random() * 10000,
expenses: Math.random() * 5000,
num1: Math.random() * 5000,
num2: Math.random() * 5000,
num3: Math.random() * 5000,
num4: Math.random() * 5000,
num5: Math.random() * 5000,
});
}
return data;
};
export const data = getData();
(function (global) {
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.50-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'cdn:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
'@mescius/wijmo.react.chart.analytics': 'cdn:@mescius/wijmo.react.chart.analytics/index.js',
'@mescius/wijmo.react.chart.animation': 'cdn:@mescius/wijmo.react.chart.animation/index.js',
'@mescius/wijmo.react.chart.annotation': 'cdn:@mescius/wijmo.react.chart.annotation/index.js',
'@mescius/wijmo.react.chart.finance.analytics': 'cdn:@mescius/wijmo.react.chart.finance.analytics/index.js',
'@mescius/wijmo.react.chart.finance': 'cdn:@mescius/wijmo.react.chart.finance/index.js',
'@mescius/wijmo.react.chart.hierarchical': 'cdn:@mescius/wijmo.react.chart.hierarchical/index.js',
'@mescius/wijmo.react.chart.interaction': 'cdn:@mescius/wijmo.react.chart.interaction/index.js',
'@mescius/wijmo.react.chart.radar': 'cdn:@mescius/wijmo.react.chart.radar/index.js',
'@mescius/wijmo.react.chart': 'cdn:@mescius/wijmo.react.chart/index.js',
'@mescius/wijmo.react.core': 'cdn:@mescius/wijmo.react.core/index.js',
'@mescius/wijmo.react.chart.map': 'cdn:@mescius/wijmo.react.chart.map/index.js',
'@mescius/wijmo.react.gauge': 'cdn:@mescius/wijmo.react.gauge/index.js',
'@mescius/wijmo.react.grid.detail': 'cdn:@mescius/wijmo.react.grid.detail/index.js',
'@mescius/wijmo.react.grid.filter': 'cdn:@mescius/wijmo.react.grid.filter/index.js',
'@mescius/wijmo.react.grid.grouppanel': 'cdn:@mescius/wijmo.react.grid.grouppanel/index.js',
'@mescius/wijmo.react.grid.search': 'cdn:@mescius/wijmo.react.grid.search/index.js',
'@mescius/wijmo.react.grid.multirow': 'cdn:@mescius/wijmo.react.grid.multirow/index.js',
'@mescius/wijmo.react.grid.sheet': 'cdn:@mescius/wijmo.react.grid.sheet/index.js',
'@mescius/wijmo.react.grid.transposed': 'cdn:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'cdn:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'cdn:@mescius/wijmo.react.grid.immutable/index.js',
'@mescius/wijmo.react.grid': 'cdn:@mescius/wijmo.react.grid/index.js',
'@mescius/wijmo.react.input': 'cdn:@mescius/wijmo.react.input/index.js',
'@mescius/wijmo.react.olap': 'cdn:@mescius/wijmo.react.olap/index.js',
'@mescius/wijmo.react.viewer': 'cdn:@mescius/wijmo.react.viewer/index.js',
'@mescius/wijmo.react.nav': 'cdn:@mescius/wijmo.react.nav/index.js',
'@mescius/wijmo.react.base': 'cdn:@mescius/wijmo.react.base/index.js',
'@mescius/wijmo.react.barcode.common': 'cdn:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'cdn:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'cdn:@mescius/wijmo.react.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
react: 'pcdn:react@19.0.0/index.js',
'react-dom': 'pcdn:react-dom@19.0.0/index.js',
'react-dom/client': 'pcdn:react-dom@19.0.0/client.js',
scheduler: 'pcdn:scheduler@0.25.0/index.js',
redux: 'pcdn:redux@5.0.1/dist/redux.legacy-esm.js',
'react-redux': 'pcdn:react-redux@9.2.0/dist/react-redux.legacy-esm.js',
'bootstrap.css': 'pcdn:bootstrap@3.3.7/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
'react-use-event-hook': 'pcdn:react-use-event-hook@0.9.6/dist/esm/useEvent.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);